// пульт для светильников 
// 4 канала ИК + для всех 
// 8 цветов
// 8 программ свечения
// отправка ИК команд (не реализовано) 

#include <CapTouch.h>

const int PINS[]={0,P2_0,P2_1,P2_2,P2_3,P2_4,P2_5};
const int LEDS[]={0,P1_0,P1_3,P1_4,P1_5,P1_6,P1_7};
const boolean LEDS_MODE[11][6]={
                       {0,0,0,0,0,0}, // спящий режим
                       {0,0,1,0,0,0}, // выбор пульта 1
                       {0,0,1,1,0,0}, // выбор пульта 2
                       {0,0,1,1,1,0}, // выбор пульта 3
                       {0,0,1,1,1,1}, // выбор пульта 4
                       {0,1,0,1,1,1}, // выбор пульта 5
                       {0,1,0,0,1,1}, // выбор пульта 6
                       {0,1,0,0,0,1}, // выбор пульта 7
                       {0,1,0,0,0,0} // выбор пульта 8
                       };
const int choice_command[]={0,1,1,1,1,0,1,0,1,1,0,0,1,0,0,0};                      
int mode=0;
int sleep=0;
int base_counts[7];
unsigned int count, base_count,delta_count;
int state = 0;

static const unsigned int threshold = 150;
static const unsigned int threshold2 = 250;
CapTouch touch1;


void setup() {
  Serial.begin(9600);
  for(int i=1;i<7;i++)
   {touch1.add(PINS[i]);
   base_counts[i]=touch1.measure(PINS[i]);
    pinMode(LEDS[i], OUTPUT);
   }
  //for(int i=0;i<6;i++)
  //  pinMode(LEDS[i], OUTPUT);
}

void loop()
{
 change_mode(get_pressed());
 establish_leds(mode);
 delay(500);
}

// проверка touch-клавиш на нажатие
int get_pressed()
  {
  int pos=0;
  for(int i=0;i<7;i++)
    {
    count = touch1.measure(PINS[i]);
    if(base_counts[i] < count) 
      {base_counts[i] = (base_counts[i] + count) >> 1;
      delta_count = 0;}
    else 
      {delta_count = base_counts[i] - count;}
    if(delta_count > threshold) 
      {
       //Serial.print(i);Serial.print("-");
       //Serial.print(delta_count);Serial.print("   ");
       uint16_t bitmask = 1;
       if (i >0)
        {for (int j = 0; j < i-1; ++j) 
	    bitmask <<= 1;
        }
       pos=pos+bitmask;
       if(delta_count>280 && i==1)
         sleep=1;
      }

    else 
      {base_count = base_count - 1;}
    delay(10);
   }   
 return pos;
 }
 // установить светодиоды для режима
 void establish_leds(int mode)
   {
   for(int i=1;i<7;i++) 
    digitalWrite(LEDS[i],LEDS_MODE[mode][i-1]);  
   }
 // изменить режим после нажатия
 void change_mode(int pos)
   {
   //Serial.print("pos=");Serial.print(pos);
   //Serial.print(" mode=");Serial.println(mode);
   //Serial.print(" sleep=");Serial.println(sleep);
   // анализ нажатий
   // переход в спящий режим
   if(sleep==1) 
     {mode=0;sleep=0;
     return;}
   // выбор следующего режима
   if(bitRead(pos,0) && bitRead(pos,5))
     {mode=mode+1;mode=min(8,mode);
      return;} 
   // выбор предыдущего режима
   if(bitRead(pos,5))
     {mode=mode-1;mode=max(1,mode);
      return;} 
   // выбор цвета или режима 
   byte bpos;
   bpos=lowByte(pos); 
   bitClear(bitClear(bpos,0),5);
   bpos=bpos>>1; 
   //Serial.print(" bpos=");Serial.println(bpos);
   if(mode>0 && choice_command[bpos])
     {send_command(mode,bpos);
     return;}
   } 
// изменить режим после нажатия
 void send_command(int high,byte low)
   { 
   byte bsend; 
   bsend=lowByte(high)<<4; 
   //Serial.print(" send1=");//Serial.println(bsend,HEX);
   bsend+=low;
   //Serial.print(" send=");
   Serial.println(bsend,HEX);
   digitalWrite(P1_0,HIGH);
   delay(500); 
   digitalWrite(P1_0,LOW);
   } 
